import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
import java.util.ArrayList;

/**
 * Write a description of class myWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class myWorld extends World
{

    //     public static int direction;

    public static final int SOUTH = 4;

    public static final int NORTH = 3;

    public static final int EAST = 1;

    public static final int WEST = 2;

    public static final int TILESIZE = 64;

    public static final int TOTALLEVEL = 3;

    public static int LEVEL = 1;

    public int width=640;

    public int heigth=640;

    private GreenfootImage im , bim;

    private Background bg;

    private Man man;
    private NPC npc;

    private ArrayList<Flag> flags;

    private ArrayList<Case> cases;

    private boolean GameOver = false;

    private boolean levelUp = false;
    String keycode;
    private Font font;

    public myWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(640, 640, 1);

        init();

        showTitle();
    }

    public void init(){

        bg = new Background();

        flags = new ArrayList<Flag>();
        cases = new ArrayList<Case>();
        for (int i = 0; i < Background.map.length; i++) {
            for (int j = 0; j < Background.map[i].length; j++) {
                if (Background.map[j][i] == 2) {
                    Case ca = new Case();
                    ca.setX(i);
                    ca.setY(j);
                    cases.add(ca);
                }
                else  if (Background.map[j][i] == 9) {
                    Flag flag = new Flag();
                    flag.setX(i);
                    flag.setY(j);
                    flags.add(flag);
                }
                else if(Background.map[j][i] == 5){
                    npc = new NPC();
                    npc.setX(i * myWorld.TILESIZE);
                    npc.setY(j * myWorld.TILESIZE);
                    Background.map[j][i] = 0;
                }
                else if(Background.map[j][i] == 3){
                    man = new Man();
                    man .setX(i * myWorld.TILESIZE);
                    man .setY(j * myWorld.TILESIZE);
                    Background.map[j][i] = 0;
                }

            }
        }

    }

    public void showTitle(){
        im=getBackground();
        //         bim=new GreenfootImage(im);
        Font font = new Font("Arial", Font.BOLD, 30);
        im.setFont(font);
        im.setColor(Color.black);
        im.drawString("Push Rocks with" , 100, 200);
        //    im.setColor(Color.red);     
        im.drawString("  Smooth Moving",330,200);
        font = new Font("Arial", Font.BOLD, 15);
        im.setFont(font);

        im.drawString("Click \"Run\" to Start..." , 220, 280);
        setBackground(im); 
    }

    public void gamePaint() {
        setBackground(im); 
    }

    public void gameRender() {
        if (im == null) {
            im =new GreenfootImage(width, heigth);
        }
        im.setColor(Color.WHITE);
        im.fillRect(0, 0, width, heigth);
        //         im.drawImage(bim,0,0);
        bg.draw(im);

        for (int i = 0; i < flags.size(); i++) {
            Flag flag = flags.get(i);
            flag.draw(im);
        }

        man.draw(im);   
        npc.draw(im);

        for (int i = 0; i < cases.size(); i++) {
            cases.get(i).draw(im);
        }	

        font = new Font("Arial", Font.BOLD, 30);
        im.setFont(font);
        im.setColor(Color.black);
        if (GameOver == false) {

            im.drawString("level" + LEVEL, 10, 30);

        } else if (LEVEL <= TOTALLEVEL){
            im.drawString("level" + (LEVEL), 10, 30);
            font = new Font("Arial", Font.BOLD, 90);
            im.setFont(font);
            im.setColor(Color.black);
            im.drawString("Failed!",200, heigth / 2);
        }
        else{

            im.drawString("level" + (LEVEL-1), 10, 30);
            font = new Font("Arial", Font.BOLD, 90);
            im.setFont(font);
            im.setColor(Color.black);
            im.drawString("finished!", 100, heigth / 2);
        }

    }

    public void gameUpdate() {

        if (GameOver == false) {
            checkLevelUp();
            checkCollision();
            man.update();

            if(npc.killed==false){
                npc.update();
            }
            else {
                npc.setX(-100);
                npc.setY(-100);
            }

            for (int i = 0; i < cases.size(); i++) {
                cases.get(i).update();
            }

        }

    }

    public void act() {
        testkeyPressed();
        gameUpdate();
        gameRender();
        gamePaint();
    }

    public void testkeyPressed() {

        if(Greenfoot.isKeyDown("r")){
            if (GameOver == true) {
                GameOver = false;  
                if(LEVEL >TOTALLEVEL)
                    LEVEL=0;
            } 
            init();  

        }

        if(Greenfoot.isKeyDown("down"))
            man.setDirection(SOUTH);

        else if(Greenfoot.isKeyDown("up"))
            man.setDirection(NORTH);

        else if(Greenfoot.isKeyDown("right"))
            man.setDirection(EAST);

        else if(Greenfoot.isKeyDown("left"))
            man.setDirection(WEST);
        else man.setDirection(0);

    }

    public void loadLevel() {
        GameOver = false;
        init();

    }

    public void checkLevelUp() {
        int i = 0;
        for (; i < flags.size(); i++) {
            Flag flag = flags.get(i);
            if (Background.map[flag.getY()][flag.getX()] != 2) {
                break;
            }
        }
        if (i == flags.size()) {
            levelUp = true;
        }
        if (levelUp == true) {
            levelUp = false;
            LEVEL += 1;
            if (LEVEL <= TOTALLEVEL)
            { Greenfoot.delay(30);
                loadLevel();}
            else
                GameOver = true;
        }
    }

    public boolean checkMoverCollision(int tileNum,Mover mover) {
        // check if Man is collided with other tiles
        int nextX = 0, nextY = 0, nextTileX = 0, nextTileY = 0;
        nextX = (int) mover.nextPosition(mover.getDirection()).getX();
        nextY = (int) mover.nextPosition(mover.getDirection()).getY();
        nextTileX = nextX / TILESIZE;
        nextTileY = nextY / TILESIZE;

        switch (mover.getDirection()) {
            case EAST:
            if (Background.map[nextTileY][nextTileX + 1] == tileNum) {
                if (mover.getY() % TILESIZE < TILESIZE / 4 * 3) {
                    mover.setX(nextTileX * TILESIZE);
                    return true;
                } else {
                    mover.setY((nextTileY + 1) * TILESIZE);
                    return false;
                }
            } else if (Background.map[nextTileY + 1][nextTileX + 1] == tileNum) {
                if (mover.getY() % TILESIZE > TILESIZE / 4) {
                    mover.setX( nextTileX * TILESIZE);
                    return true;
                } else {
                    mover.setY( nextTileY * TILESIZE);
                    return false;
                }
            } else
                return false;
            case WEST:
            if (Background.map[nextTileY][nextTileX] == tileNum) {
                if (mover.getY() % TILESIZE < TILESIZE / 4 * 3) {
                    mover.setX((nextTileX + 1) * TILESIZE );
                    return true;
                } else {
                    mover.setY((nextTileY + 1) * TILESIZE);
                    return false;
                }
            } else if (Background.map[nextTileY + 1][nextTileX] == tileNum) {
                if (mover.getY()% TILESIZE > TILESIZE / 4) {
                    mover.setX((nextTileX + 1) * TILESIZE);
                    return true;
                } else {
                    mover.setY( nextTileY * TILESIZE);
                    return false;
                }
            } else
                return false;
            case NORTH:
            if (Background.map[nextTileY][nextTileX] == tileNum) {
                if (mover.getX() % TILESIZE < TILESIZE / 4 * 3) {
                    mover.setY((nextTileY + 1) * TILESIZE);
                    return true;
                } else {
                    mover.setX( (nextTileX + 1) * TILESIZE);
                    return false;
                }
            } else if (Background.map[nextTileY][nextTileX + 1] == tileNum) {
                if (mover.getX() % TILESIZE > TILESIZE / 4) {
                    mover.setY((nextTileY + 1) * TILESIZE);
                    return true;
                } else {
                    mover.setX( nextTileX * TILESIZE);
                    return false;
                }
            } else
                return false;
            case SOUTH:
            if (Background.map[nextTileY + 1][nextTileX] == tileNum) {

                if (mover.getX() % TILESIZE < TILESIZE / 4 * 3) {
                    mover.setY( nextTileY * TILESIZE);
                    return true;
                } else {
                    mover.setX((nextTileX + 1) * TILESIZE);
                    return false;
                }
            } else if (Background.map[nextTileY + 1][nextTileX + 1] == tileNum) {
                if (mover.getX() % TILESIZE > TILESIZE / 4) {
                    mover.setY(nextTileY * TILESIZE);
                    return true;
                } else {
                    mover.setX( nextTileX * TILESIZE);
                    return false;
                }
            } else
                return false;
            default:
            return false;
        }
    }

    public void checkMoverToWall(Mover mover) {

        if (checkMoverCollision(1,mover) == true) {
            mover.setCollisionToWall(true);
        } else {
            mover.setCollisionToWall(false);
        }
    }

    public void checkCaseToMover(Case ca,Mover mover) {
        // check the collision between man and case
        int nextX = 0, nextY = 0;
        nextX = (int) mover.nextPosition(mover.getDirection()).getX();
        nextY = (int) mover.nextPosition(mover.getDirection()).getY();

        if (Math.abs(ca.getX() * TILESIZE - nextX) <= TILESIZE / 8 * 6
        && Math.abs(ca.getY() * TILESIZE - nextY) <= TILESIZE / 8 * 6) {
            if(mover instanceof Man){ 
                ca.collisionToMan = true;
                ca.direction=man.getDirection();
            }
            else if(mover instanceof NPC) {
                //                 ca.collisionToNPC = true;
                npc.collisionToCase = true;
            }
        } else {
            if(mover instanceof Man){
                ca.collisionToMan = false;
            }
            else if(mover instanceof NPC) {
                nextX = (int) ca.nextPosition(ca.direction).getX();
                nextY = (int) ca.nextPosition(ca.direction).getY();
                if (Math.abs(nextX * TILESIZE - npc.getX()) <= TILESIZE / 8 * 6
                && Math.abs(nextY * TILESIZE - npc.getY()) <= TILESIZE / 8 * 6) {
                    npc.killed=true;
                }
            }
        }
    }

    public void checkCaseToBlock(Case ca) {
        // check the collision between case and wall or other cases
        int nextX = 0, nextY = 0;
        nextX = (int) ca.nextPosition(ca.direction).getX();
        nextY = (int) ca.nextPosition(ca.direction).getY();
        if (Background.map[nextY][nextX] == 0
        || Background.map[nextY][nextX] == 9) {
            ca.collisionToBlock = false;
        } else {
            ca.collisionToBlock = true;
        }
    }

    public void checkManToNPC(){        
        if (Math.abs(man.getX() -npc.getX()) <= TILESIZE/ 8 * 6 
        && Math.abs(man.getY() -npc.getY()) <= TILESIZE/ 8 * 6 ) 
            GameOver=true;
    }

    public void checkCollision() {
        // check the collision between man and case
        int i = 0;
        for (i = 0; i < cases.size(); i++) {
            checkCaseToMover(cases.get(i),man);
            if (cases.get(i).collisionToMan == true) {
                break;
            }
        }
        if (i == cases.size()) { // none of cases were collided
            man.collisionToCase = false;
        } else {
            man.collisionToCase = true;
        }

        // check the collision between case and wall or other cases
        for (int j = 0; j < cases.size(); j++) {
            checkCaseToMover(cases.get(j),npc);
            checkCaseToBlock(cases.get(j));
        }
        // check the collision between man and case
        checkMoverToWall(man);
        if(npc.killed==false) 
            checkMoverToWall(npc);

        checkManToNPC();
    }

    //     public static int getDirection() {
    //         return direction;
    //     }

}
